// hueControl digitalSTROM server add-on
// for controlling Philips Hue LED lamps
// (c) 2012 by plan44.ch
//
// Background operation (responding to events according to config)

function restoreState(lightID) {
  lInfo.logln("restoreState for bulb " + lightID);
  applyStateToLight(JSON.parse(Property.getProperty('backup/'+lightID+'/state')), lightID);
}

function performSceneInZone(aSceneID,aZoneID) {
  lInfo.logln("performScene " + String(aSceneID) + " InZone " + String(aZoneID));
  // decode scene
  var lightSceneNo = -1; // invalid
  switch (parseInt(aSceneID)) {
    // room scenes
    case 0  : lightSceneNo = 0; break; // Raumtaster Ausszene
    case 5  : lightSceneNo = 1; break; // Raumtaster Einszene
    case 17 : lightSceneNo = 2; break; // Raumtaster Szene 2
    case 18 : lightSceneNo = 3; break; // Raumtaster Szene 3
    case 19 : lightSceneNo = 4; break; // Raumtaster Szene 4
    // area scenes
    // - Area 1
    case 1  : lightSceneNo = 10; break; // Bereich 1 Ausszene
    case 6  : lightSceneNo = 11; break; // Bereich 1 Einszene
    case 20 : lightSceneNo = 12; break; // Bereich 1 Szene 2 (Stimmung 12)
    case 21 : lightSceneNo = 13; break; // Bereich 1 Szene 3 (Stimmung 13)
    case 22 : lightSceneNo = 14; break; // Bereich 1 Szene 4 (Stimmung 14)
    // - Area 2    
    case 2  : lightSceneNo = 20; break; // Bereich 2 Ausszene
    case 7  : lightSceneNo = 21; break; // Bereich 2 Einszene
    case 23 : lightSceneNo = 22; break; // Bereich 2 Szene 2 (Stimmung 22)
    case 24 : lightSceneNo = 23; break; // Bereich 2 Szene 3 (Stimmung 23)
    case 25 : lightSceneNo = 24; break; // Bereich 2 Szene 4 (Stimmung 24)
    // - Area 3
    case 3  : lightSceneNo = 30; break; // Bereich 3 Ausszene
    case 8  : lightSceneNo = 31; break; // Bereich 3 Einszene
    case 26 : lightSceneNo = 32; break; // Bereich 3 Szene 2 (Stimmung 32)
    case 27 : lightSceneNo = 33; break; // Bereich 3 Szene 3 (Stimmung 33)
    case 28 : lightSceneNo = 34; break; // Bereich 3 Szene 4 (Stimmung 34)
    // - Area 4
    case 4  : lightSceneNo = 40; break; // Bereich 4 Ausszene
    case 9  : lightSceneNo = 41; break; // Bereich 4 Einszene
    case 29 : lightSceneNo = 42; break; // Bereich 4 Szene 2 (Stimmung 42)
    case 30 : lightSceneNo = 43; break; // Bereich 4 Szene 3 (Stimmung 43)
    case 31 : lightSceneNo = 44; break; // Bereich 4 Szene 4 (Stimmung 44)
    // appartment scenes
    case 67 : lightSceneNo = 0; break;  // Standby
    case 68 : lightSceneNo = 0; break;  // Deep_Off
    case 69 : lightSceneNo = 0; break;  // Schlafen
    case 72 : lightSceneNo = 72; break; // Gehen
    case 71 : lightSceneNo = 71; break; // Kommen
    case 65 : lightSceneNo = 65; break; // Panik
    case 73 : lightSceneNo = 73; break; // Klingel
    case 74 : lightSceneNo = 74; break; // Alarm
    case 76 : lightSceneNo = 76; break; // Feuer
  }
  lInfo.logln("- light scene=" + String(lightSceneNo));
  if (lightSceneNo>=0) {
    // get light configs
    var lightConfigs = Property.getNode('lights').getChildren();
    lInfo.logln("lightconfigs: loaded");
    // valid scene for hue lights
    var zoneID = parseInt(aZoneID);
    lInfo.logln("- requested zone=" + String(zoneID));
    for (var li=0; li<lightConfigs.length; li++) {
      var lightConfig = lightConfigs[li];
      // get the light's zone
      var lightZoneProp = lightConfig.getChild('zoneID');
      var lightZone = parseInt(lightZoneProp.getValue());        
      lInfo.logln("- light zone=" + String(lightZone));
      if (zoneID==0 || lightZone==zoneID) {
        // this light is affected (is in the called zone)
        lInfo.logln("- zone matches");
        var sceneProp = lightConfig.getChild('scene' + String(lightSceneNo));
        var sceneDontCareProp = sceneProp.getChild('dontCare');
        var sceneDontCare = sceneDontCareProp.getValue();
        lInfo.logln("- don't care = " + sceneDontCare);
        if (sceneDontCare == false) {
          var lightIDProp = lightConfig.getChild('lightID');
          var lightID = parseInt(lightIDProp.getValue());
          // apply the state now
          lInfo.logln("- applying state to light ID " + String(lightID));
          var stateTextProp = sceneProp.getChild('state');
          var stateText = stateTextProp.getValue();
          if (lightSceneNo == 73) {
            // state sichern
            var state = getLightState(lightID);
            Property.setProperty('backup/'+lightID+'/state',JSON.stringify(state));
            
            stateText = '{"on":true,"bri":255,"sat":255,"alert":"lselect","hue":25000}'; // flash green
          }
          lInfo.logln("- state = " + stateText);
          if (stateText) {
            var state = JSON.parse(stateText);
            applyStateToLight(state,lightID);
            var o=function() {
            	restoreState(lightID);
            }
            if (lightSceneNo == 73) {
                setTimeout(o, 5000);
            }
          }
        } // if scene Don't Care is not set
      } // if light is in the requested zone
    } // for each light we have
  } // if scene possibly applicable to hue lights
}



// Event dispatcher

if (raisedEvent.name == 'callSceneBus') {
  // only perform scenes in light group (1) or broadcast (0)
  if (raisedEvent.source.groupID==0 || raisedEvent.source.groupID==1) {
    // light or broadcast, we need to check the config to know what to do
    Property.load();
    if (raisedEvent.source.isDevice) {
      lInfo.logln("callScene from device, currently unhandled");
    }
    else {
      performSceneInZone(raisedEvent.parameter.sceneID, raisedEvent.source.zoneID);
    }
  }
}

